const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Islamic_finance_libraryDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const islamic_finance_library = await db.islamic_finance_library.create(
      {
        id: data.id || undefined,

        title: data.title || null,
        content: data.content || null,
        resource_type: data.resource_type || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await islamic_finance_library.setKooperatif(data.kooperatif || null, {
      transaction,
    });

    return islamic_finance_library;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const islamic_finance_libraryData = data.map((item, index) => ({
      id: item.id || undefined,

      title: item.title || null,
      content: item.content || null,
      resource_type: item.resource_type || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const islamic_finance_library = await db.islamic_finance_library.bulkCreate(
      islamic_finance_libraryData,
      { transaction },
    );

    // For each item created, replace relation files

    return islamic_finance_library;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const islamic_finance_library = await db.islamic_finance_library.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.title !== undefined) updatePayload.title = data.title;

    if (data.content !== undefined) updatePayload.content = data.content;

    if (data.resource_type !== undefined)
      updatePayload.resource_type = data.resource_type;

    updatePayload.updatedById = currentUser.id;

    await islamic_finance_library.update(updatePayload, { transaction });

    if (data.kooperatif !== undefined) {
      await islamic_finance_library.setKooperatif(
        data.kooperatif,

        { transaction },
      );
    }

    return islamic_finance_library;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const islamic_finance_library = await db.islamic_finance_library.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of islamic_finance_library) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of islamic_finance_library) {
        await record.destroy({ transaction });
      }
    });

    return islamic_finance_library;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const islamic_finance_library = await db.islamic_finance_library.findByPk(
      id,
      options,
    );

    await islamic_finance_library.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await islamic_finance_library.destroy({
      transaction,
    });

    return islamic_finance_library;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const islamic_finance_library = await db.islamic_finance_library.findOne(
      { where },
      { transaction },
    );

    if (!islamic_finance_library) {
      return islamic_finance_library;
    }

    const output = islamic_finance_library.get({ plain: true });

    output.kooperatif = await islamic_finance_library.getKooperatif({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userKooperatif = (user && user.kooperatif?.id) || null;

    if (userKooperatif) {
      if (options?.currentUser?.kooperatifId) {
        where.kooperatifId = options.currentUser.kooperatifId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.kooperatif,
        as: 'kooperatif',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.title) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'islamic_finance_library',
            'title',
            filter.title,
          ),
        };
      }

      if (filter.content) {
        where = {
          ...where,
          [Op.and]: Utils.ilike(
            'islamic_finance_library',
            'content',
            filter.content,
          ),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.resource_type) {
        where = {
          ...where,
          resource_type: filter.resource_type,
        };
      }

      if (filter.kooperatif) {
        const listItems = filter.kooperatif.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          kooperatifId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.kooperatifId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.islamic_finance_library.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('islamic_finance_library', 'title', query),
        ],
      };
    }

    const records = await db.islamic_finance_library.findAll({
      attributes: ['id', 'title'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['title', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.title,
    }));
  }
};
